Index: /branches/network/src/lib/network/network_game_manager.cc
===================================================================
--- /branches/network/src/lib/network/network_game_manager.cc	(revision 6462)
+++ /branches/network/src/lib/network/network_game_manager.cc	(revision 6463)
@@ -478,18 +478,4 @@
     PRINTF(0)("Fabricated %s with id %d\n", s->getClassName(), s->getUniqueID());
 
-
-    if( !strcmp( s->getClassName(), "SkyBox"))
-    {
-      PRINTF(0)("==> Created the Sky!\n");
-      (dynamic_cast<GameWorld*>(State::getCurrentStoryEntity()))->setSky( dynamic_cast<WorldEntity*>(s) );
-    }
-//       this->sky = dynamic_cast<WorldEntity*>(created);
-    if( !strcmp( s->getClassName(), "Terrain"))
-    {
-      PRINTF(0)("==> Created the Terrain\n");
-//       this->terrain = dynamic_cast<Terrain*>(created);
-//       CDEngine::getInstance()->setTerrain(terrain);
-    }
-
     return b;
   }
Index: /branches/network/src/story_entities/multi_player_world.cc
===================================================================
--- /branches/network/src/story_entities/multi_player_world.cc	(revision 6462)
+++ /branches/network/src/story_entities/multi_player_world.cc	(revision 6463)
@@ -21,4 +21,5 @@
 #include "factory.h"
 #include "load_param.h"
+#include "shell_command.h"
 
 #include "network_manager.h"
@@ -26,4 +27,8 @@
 
 using namespace std;
+
+
+//! Register a command to print some multiplayer world infos
+SHELL_COMMAND(debug, MultiPlayerWorld, debug);
 
 
@@ -79,2 +84,10 @@
 }
 
+
+/**
+ * some debug ouptut - shell command
+ */
+void MultiPlayerWorld::debug()
+{
+  ((MultiPlayerWorldData*)this->dataTank)->debug();
+}
Index: /branches/network/src/story_entities/multi_player_world.h
===================================================================
--- /branches/network/src/story_entities/multi_player_world.h	(revision 6462)
+++ /branches/network/src/story_entities/multi_player_world.h	(revision 6463)
@@ -27,4 +27,6 @@
   void loadParams(const TiXmlElement* root);
 
+  void debug();
+
   protected:
     virtual void synchronize();
Index: /branches/network/src/story_entities/multi_player_world_data.cc
===================================================================
--- /branches/network/src/story_entities/multi_player_world_data.cc	(revision 6462)
+++ /branches/network/src/story_entities/multi_player_world_data.cc	(revision 6463)
@@ -187,20 +187,4 @@
     }
 
-    /* some debug output */
-    PRINT(0)("==================================================\n");
-    std::list<BaseObject*>::const_iterator entity;
-    for (entity = playableList->begin(); entity != playableList->end(); entity++)
-    {
-      PRINTF(0)("Got a playable, class: %s, name: %s\n", (*entity)->getClassName(), (*entity)->getName());
-    }
-
-
-    PNode* cam = State::getCameraTarget();
-    PRINT(0)("Camera has target - class: %s, name: %s, uid: %i\n", cam->getClassName(), cam->getName(), cam->getUniqueID());
-
-
-    PRINT(0)("==================================================\n");
-
-
     /* init the pnode tree */
     PNode::getNullParent()->init();
@@ -239,2 +223,43 @@
 }
 
+
+/**
+ * some debug output
+ */
+void MultiPlayerWorldData::debug()
+{
+  PRINT(0)("==================================================\n");
+  Playable* playable;
+  const std::list<BaseObject*>* playableList = ClassList::getList(CL_PLAYABLE);
+  assert(playableList != NULL);
+  std::list<BaseObject*>::const_iterator entity;
+  for (entity = playableList->begin(); entity != playableList->end(); entity++)
+  {
+    Playable* p = dynamic_cast<Playable*>(*entity);
+    PRINTF(0)("Got a playable, class: %s, name: %s, uid: %i\n", (*entity)->getClassName(), (*entity)->getName(), p->getUniqueID());
+  }
+
+  PNode* cam = State::getCameraTarget();
+  PRINT(0)("Camera has target - class: %s, name: %s, uid: %i\n", cam->getClassName(), cam->getName(), cam->getUniqueID());
+
+  PRINT(0)("==================================================\n");
+
+}
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
Index: /branches/network/src/story_entities/multi_player_world_data.h
===================================================================
--- /branches/network/src/story_entities/multi_player_world_data.h	(revision 6462)
+++ /branches/network/src/story_entities/multi_player_world_data.h	(revision 6463)
@@ -24,4 +24,6 @@
     virtual ErrorMessage init();
 
+    void debug();
+
 
   protected:
Index: /branches/network/src/world_entities/space_ships/space_ship.cc
===================================================================
--- /branches/network/src/world_entities/space_ships/space_ship.cc	(revision 6462)
+++ /branches/network/src/world_entities/space_ships/space_ship.cc	(revision 6463)
@@ -211,6 +211,4 @@
   dynamic_cast<Element2D*>(this->getWeaponManager()->getFixedTarget())->setVisibility( true);
   this->attachCamera();
-
-
 }
 
@@ -315,11 +313,11 @@
 
   //readjust
-  
+
   /*
     In the game "Yager" the spaceship gets readjusted when the player moves the mouse.
     I (bknecht) go and check it out how they do it, we could probably use this also in Orxonox.
   */
-  //if (xMouse != 0 && yMouse != 0) 
-  
+  //if (xMouse != 0 && yMouse != 0)
+
   //if (this->getAbsDirZ().y > 0.1) this->shiftDir(Quaternion(time*0.3, Vector(1,0,0)));
   //else if (this->getAbsDirZ().y < -0.1) this->shiftDir(Quaternion(-time*0.3, Vector(1,0,0)));