Index: branches/network/src/lib/coord/p_node.cc
===================================================================
--- branches/network/src/lib/coord/p_node.cc	(revision 6482)
+++ branches/network/src/lib/coord/p_node.cc	(revision 6483)
@@ -1039,6 +1039,4 @@
   SYNCHELP_READ_FKT( BaseObject::writeState );
 
-  //PRINTF(0)("name = %s\n", this->getName());
-
   char * parentName = NULL;
   SYNCHELP_READ_STRINGM( parentName );
@@ -1065,9 +1063,9 @@
   SYNCHELP_READ_FLOAT( f3 );
   this->setRelCoor( f1, f2, f3 );
-  //this->setRelCoor( 10, 0, 0 );
-
-  SYNCHELP_READ_FLOAT( f1 );
+  //this->setRelCoor( 5, 0, 0 );
+
+  /*SYNCHELP_READ_FLOAT( f1 );
   SYNCHELP_READ_FLOAT( f2 );
-  SYNCHELP_READ_FLOAT( f3 );
+  SYNCHELP_READ_FLOAT( f3 );*/
   //this->setAbsCoor( f1, f2, f3 );
 
@@ -1078,8 +1076,8 @@
   this->setRelDir( Quaternion( Vector(f2, f3, f4), f1 ) );
 
-  SYNCHELP_READ_FLOAT( f1 );
+  /*SYNCHELP_READ_FLOAT( f1 );
   SYNCHELP_READ_FLOAT( f2 );
   SYNCHELP_READ_FLOAT( f3 );
-  SYNCHELP_READ_FLOAT( f4 );
+  SYNCHELP_READ_FLOAT( f4 );*/
   //this->setAbsDir( Quaternion( Vector(f2, f3, f4), f1 ) );
 
@@ -1113,6 +1111,4 @@
   SYNCHELP_WRITE_FKT( BaseObject::readState );
 
-  //PRINTF(0)("name = %s\n", this->getName());
-
   if ( this->parent )
   {
@@ -1132,7 +1128,7 @@
   //PRINTF(0)("%s, %f, %f, %f\n", getClassName(), relCoordinate.x, relCoordinate.y, relCoordinate.z);
 
-  SYNCHELP_WRITE_FLOAT( this->absCoordinate.x );
+  /*SYNCHELP_WRITE_FLOAT( this->absCoordinate.x );
   SYNCHELP_WRITE_FLOAT( this->absCoordinate.y );
-  SYNCHELP_WRITE_FLOAT( this->absCoordinate.z );
+  SYNCHELP_WRITE_FLOAT( this->absCoordinate.z );*/
 
   //PRINTF(0)("%s, %f, %f, %f\n", getClassName(), absCoordinate.x, absCoordinate.y, absCoordinate.z);
@@ -1143,8 +1139,8 @@
   SYNCHELP_WRITE_FLOAT( this->relDirection.v.z );
 
-  SYNCHELP_WRITE_FLOAT( this->absDirection.w );
+  /*SYNCHELP_WRITE_FLOAT( this->absDirection.w );
   SYNCHELP_WRITE_FLOAT( this->absDirection.v.x );
   SYNCHELP_WRITE_FLOAT( this->absDirection.v.y );
-  SYNCHELP_WRITE_FLOAT( this->absDirection.v.z );
+  SYNCHELP_WRITE_FLOAT( this->absDirection.v.z );*/
 
   int n = children.size();
@@ -1155,4 +1151,5 @@
     SYNCHELP_WRITE_STRING( (*it)->getName() );
   }
+
   return SYNCHELP_WRITE_N;
 }
Index: branches/network/src/lib/lang/base_object.cc
===================================================================
--- branches/network/src/lib/lang/base_object.cc	(revision 6482)
+++ branches/network/src/lib/lang/base_object.cc	(revision 6483)
@@ -199,4 +199,9 @@
   }
   SYNCHELP_READ_STRINGM( this->objectName );
+  if ( this->objectName && !strcmp(this->objectName, "") )
+  {
+    delete[] this->objectName;
+    this->objectName = NULL;
+  }
 
   return SYNCHELP_READ_N;
Index: branches/network/src/lib/network/network_game_manager.cc
===================================================================
--- branches/network/src/lib/network/network_game_manager.cc	(revision 6482)
+++ branches/network/src/lib/network/network_game_manager.cc	(revision 6483)
@@ -164,5 +164,4 @@
     SYNCHELP_WRITE_BYTE( b );
     hasRequestedWorld = true;
-    PRINTF(0)("the world is enough! id=%d\n", this->getUniqueID());
     return SYNCHELP_WRITE_N;
   }
@@ -462,5 +461,5 @@
     PRINTF(0)("Fabricated %s with id %d\n", s->getClassName(), s->getUniqueID());
 
-    //NOTE: hack to prevent collision
+    //HACK: hack to prevent collision
     if ( b->isA(CL_WORLD_ENTITY) )
     {
Index: branches/network/src/lib/network/network_stream.cc
===================================================================
--- branches/network/src/lib/network/network_stream.cc	(revision 6482)
+++ branches/network/src/lib/network/network_stream.cc	(revision 6483)
@@ -166,5 +166,5 @@
       networkSockets[0]->destroy();
       networkSockets[0] = NULL;
-      //TODO: delete handshake from synchronizeable list so i can delete it
+
       if ( handshakes[0] )
         delete handshakes[0];
@@ -252,5 +252,5 @@
           if ( networkSockets[reciever] != NULL )
           {
-            PRINTF(0)("write %d bytes to socket %d\n", dataLength, reciever);
+            PRINTF(5)("write %d bytes to socket %d\n", dataLength, reciever);
             networkSockets[reciever]->writePacket(downBuffer, dataLength);
           }
@@ -266,5 +266,5 @@
             if ( networkSockets[i] != NULL )
             {
-              PRINTF(0)("write %d bytes to socket %d\n", dataLength, reciever);
+              PRINTF(5)("write %d bytes to socket %d\n", dataLength, reciever);
               networkSockets[i]->writePacket(downBuffer, dataLength);
             }
@@ -372,5 +372,5 @@
       networkSockets[i]->destroy();
       networkSockets[i] = NULL;
-      //TODO: delete handshake from synchronizeable list so i can delete it
+
       if ( handshakes[i] )
         delete handshakes[i];
Index: branches/network/src/world_entities/skybox.cc
===================================================================
--- branches/network/src/world_entities/skybox.cc	(revision 6482)
+++ branches/network/src/world_entities/skybox.cc	(revision 6483)
@@ -250,5 +250,4 @@
   if ( rec > 0 )
   {
-    PRINT(0)("SEND DATA: size=%f texture='%s'\n", size, textureName);
     *reciever = rec;
 
Index: branches/network/src/world_entities/space_ships/space_ship.cc
===================================================================
--- branches/network/src/world_entities/space_ships/space_ship.cc	(revision 6482)
+++ branches/network/src/world_entities/space_ships/space_ship.cc	(revision 6483)
@@ -574,5 +574,5 @@
     SYNCHELP_READ_FLOAT( xMouse );
     SYNCHELP_READ_FLOAT( yMouse );
-    SYNCHELP_READ_FLOAT( mouseSensitivity ); //TODO: remove this two lines
+    SYNCHELP_READ_FLOAT( mouseSensitivity );
     SYNCHELP_READ_FLOAT( cycle );
   }
@@ -609,5 +609,5 @@
   *reciever = 0;
 
-  if ( this->getHostID()!=this->getOwner() )
+  if ( this->getHostID()==this->getOwner() )
   {
     int mask = 0;
@@ -630,5 +630,5 @@
       mask |= MASK_bRollR;
 
-    static int oldMask = mask+1; //so it it different the first time!
+    static int oldMask = mask+1; //so it is different the first time!
     static float oldxMouse = xMouse + 1.0;
     static float oldyMouse = yMouse + 1.0;
@@ -649,5 +649,5 @@
       SYNCHELP_WRITE_FLOAT( yMouse );
       SYNCHELP_WRITE_FLOAT( mouseSensitivity );
-      SYNCHELP_WRITE_FLOAT( cycle );  //TODO: remove this two lines
+      SYNCHELP_WRITE_FLOAT( cycle );
     }
   }