Index: code/branches/pickup3/src/modules/pickup/PickupManager.cc
===================================================================
--- code/branches/pickup3/src/modules/pickup/PickupManager.cc	(revision 6483)
+++ code/branches/pickup3/src/modules/pickup/PickupManager.cc	(revision 6484)
@@ -52,4 +52,6 @@
     PickupManager::PickupManager()
     {
+        this->defaultRepresentation_ = NULL;
+        this->pickupCarrierStructure_ = NULL;
         RegisterRootObject(PickupManager);
         
@@ -85,5 +87,5 @@
     bool PickupManager::registerRepresentation(const PickupIdentifier* identifier, PickupRepresentation* representation)
     {
-        if(this->representations_.find(identifier) == this->representations_.end()) //!< If the Pickupable already has a RepresentationRegistered.
+        if(this->representations_.find(identifier) != this->representations_.end()) //!< If the Pickupable already has a RepresentationRegistered.
             return false;
         
Index: code/branches/pickup3/src/modules/pickup/PickupRepresentation.cc
===================================================================
--- code/branches/pickup3/src/modules/pickup/PickupRepresentation.cc	(revision 6483)
+++ code/branches/pickup3/src/modules/pickup/PickupRepresentation.cc	(revision 6484)
@@ -103,4 +103,9 @@
         
         PickupManager::getInstance().registerRepresentation(this->pickup_->getPickupIdentifier(), this); //!< Registers the PickupRepresentation with the PickupManager through the PickupIdentifier of the Pickupable it represents.
+        
+        if(this->spawnerRepresentation_ != NULL)
+            this->spawnerRepresentation_->setVisible(false);
+        
+        COUT(4) << "PickupRepresentation created: name: '" << this->name_ << "', description: '" << this->description_ << "', spawnerTemplate: '" << this->spawnerTemplate_ << "'." << std::endl;
     }
     
@@ -128,6 +133,8 @@
         
         StaticEntity* representation = this->spawnerRepresentation_;
+        representation->setVisible(true);
         
         this->addTemplate(this->spawnerTemplate_);
+        this->spawnerRepresentation_->setVisible(false);
         
         return representation;
Index: code/branches/pickup3/src/modules/pickup/PickupSpawner.cc
===================================================================
--- code/branches/pickup3/src/modules/pickup/PickupSpawner.cc	(revision 6483)
+++ code/branches/pickup3/src/modules/pickup/PickupSpawner.cc	(revision 6484)
@@ -147,5 +147,7 @@
         {
             PickupRepresentation* representation = PickupManager::getInstance().getRepresentation(this->pickup_->getPickupIdentifier());
+            representation->setVisible(this->isActive());
             this->attach(representation->getSpawnerRepresentation(this));
+            this->setActive(true);
         }
     }
@@ -273,6 +275,9 @@
     void PickupSpawner::trigger(Pawn* pawn)
     {
-        if (this->isActive()) //!< Checks whether PickupItem is active.
-        {
+        COUT(1) << "PickupSpawner triggered." << std::endl;
+        if (this->isActive()) //!< Checks whether PickupSpawner is active.
+        {
+            COUT(1) << "PickupSpawner triggered and active." << std::endl;
+            
             PickupCarrier* carrier = dynamic_cast<PickupCarrier*>(pawn);
             if(carrier == NULL)
Index: code/branches/pickup3/src/modules/pickup/items/HealthPickup.cc
===================================================================
--- code/branches/pickup3/src/modules/pickup/items/HealthPickup.cc	(revision 6483)
+++ code/branches/pickup3/src/modules/pickup/items/HealthPickup.cc	(revision 6484)
@@ -120,6 +120,4 @@
         if(!this->isContinuous())
             this->healthRate_ = 0.0;
-        
-        COUT(1) << "HealthPickup " << this->getHealth() << ", " << this->getHealthRate() << ", " << this->getHealthType() << "." << std::endl;
         
         this->initializeIdentifier();
Index: code/branches/pickup3/src/orxonox/pickup/PickupIdentifier.cc
===================================================================
--- code/branches/pickup3/src/orxonox/pickup/PickupIdentifier.cc	(revision 6483)
+++ code/branches/pickup3/src/orxonox/pickup/PickupIdentifier.cc	(revision 6484)
@@ -101,5 +101,5 @@
     bool PickupIdentifier::addParameter(std::string & name, std::string & value)
     {
-        COUT(1) << "PickupIdentifier " << name << ", " << value << std::endl;
+        COUT(4) << "PickupIdentifier " << name << ", " << value << std::endl;
         
         if(!(this->parameters_.find(name) == this->parameters_.end()))